(function ($) {

    window.downloadURI = function downloadURI(uri, name) {
        let link = document.createElement("a");
        link.download = name;
        link.href = uri;
        link.click();
    }

    window.downloader = function downloader(data, type, name) {
        let blob = new Blob([data], {
            type
        });
        let url = window.URL.createObjectURL(blob);
        downloadURI(url, name);
        window.URL.revokeObjectURL(url);
    }

    // standardize styling custom buttons. Must have a specific layout!
    window.style_button = function style_button(data) {
        var settings = $.extend({
                color: '#007cba',
                height: '30px',
                id: '',
                margin: '',
                width: '',
                pointer_events: 'all',
            },
            data,
        );
        $('#' + settings.id).attr('style', '\
            display: flex !important;\
            justify-content: center !important;\
            align-items: center !important;\
            width: ' + settings.width + ' !important;\
            height: ' + settings.height + ' !important;\
            background: ' + settings.color + ' !important;\
            margin: ' + settings.margin + ' !important;\
            border-color: ' + settings.color + ' !important;\
            pointer-events: ' + settings.pointer_events + ' !important;\
        ');
        $('div#' + settings.id + '_icon').attr('style', '\
            display: flex !important;\
            align-items: center !important;\
        ');
        $('div#' + settings.id + '_text').attr('style', '\
            align-items: center !important;\
            display: flex !important;\
            width: 100% !important;\
            justify-content: center !important;\
        ');
        $('#' + settings.id).on('mouseenter', function (e) {
            $(this).css({
                'box-shadow': 'inset 0 0 0 1000px rgba(0,0,0,.2)',
            });
        }).on('mouseleave', function (e) {
            $(this).css({
                'box-shadow': 'none',
            });
        });
    }

})(jQuery);